%{                                                       // -*- C++ -*-
//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2004, 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//

//
// WARNING: Generated file, do not edit by hand!
//


#include <string>

#include "common.hh"

#include "inst/label.hh"
#include "inst/program_builder.hh"
#include "inst/exp.hh"
#include "inst/register.hh"
#include "inst/all.hh"

#include "parse/libparse.hh"

using namespace inst;
%}

%require "3.0"
%skeleton "lalr1.cc"
%define parse.error verbose
%defines
%debug

%locations

%parse-param { std::string &filename }
%parse-param { inst::ProgramBuilder &program_builder }

%initial-action
{
  @$.begin.filename = @$.end.filename = &filename;
}

%union
{
  int                   i;
  std::string           *s;
  misc::unique_string   *id;
  inst::Label           *label;
  inst::Register        *reg;
  inst::Exp             *exp;
}
%{
#include "parse/asm-scan.hh"
%}

%token <id> LABEL               "label"
%token <id> LABEL_DEF           "label definition"
%token <i> INTEGER              "integer"
%token <s> STRING               "string"
%token <reg> REGISTER           "register"

%destructor { delete $$; } "string"

%destructor { delete $$; } "label"
%destructor { delete $$; } "label definition"

%printer { debug_stream () << *$$; } "string" "register"
%printer { debug_stream () << $$; } "integer"

%type <exp> exp

%token YYEOF            0 "end of file"
%token LPAREN           "("
%token RPAREN           ")"
%token COMMA            ","

%left EXP_ADD EXP_SUB
%left EXP_MUL EXP_DIV
%nonassoc EXP_UMINUS

%token DIR_TEXT         ".text"
%token DIR_DATA         ".data"

%token DIR_SPACE        ".space"
%token DIR_BYTE         ".byte"
%token DIR_HALF         ".half"
%token DIR_WORD         ".word"
%token DIR_ASCII        ".ascii"
%token DIR_ASCIIZ       ".asciiz"

%token ADD		"add"
%token ADDU		"addu"
%token ADDI		"addi"
%token ADDIU		"addiu"
%token SUB		"sub"
%token SUBU		"subu"
%token NEG		"neg"
%token NEGU		"negu"
%token ABS		"abs"
%token MUL		"mul"
%token DIV		"div"
%token DIVU		"divu"
%token REM		"rem"
%token REMU		"remu"
%token SLL		"sll"
%token SLLV		"sllv"
%token SRA		"sra"
%token SRAV		"srav"
%token SRL		"srl"
%token SRLV		"srlv"
%token ROL		"rol"
%token ROR		"ror"
%token AND		"and"
%token ANDI		"andi"
%token OR		"or"
%token ORI		"ori"
%token XOR		"xor"
%token XORI		"xori"
%token NOR		"nor"
%token NOT		"not"
%token SEQ		"seq"
%token SNE		"sne"
%token SGE		"sge"
%token SGEU		"sgeu"
%token SGT		"sgt"
%token SGTU		"sgtu"
%token SLE		"sle"
%token SLEU		"sleu"
%token SLT		"slt"
%token SLTU		"sltu"
%token SLTI		"slti"
%token SLTIU		"sltiu"
%token BEQ		"beq"
%token BEQZ		"beqz"
%token BNE		"bne"
%token BNEZ		"bnez"
%token BGE		"bge"
%token BGEU		"bgeu"
%token BGEZ		"bgez"
%token BGEZAL		"bgezal"
%token BGT		"bgt"
%token BGTU		"bgtu"
%token BGTZ		"bgtz"
%token BLE		"ble"
%token BLEU		"bleu"
%token BLEZ		"blez"
%token BLT		"blt"
%token BLTU		"bltu"
%token BLTZ		"bltz"
%token BLTZAL		"bltzal"
%token J		"j"
%token JAL		"jal"
%token JR		"jr"
%token JALR		"jalr"
%token LB		"lb"
%token LBU		"lbu"
%token LW		"lw"
%token LUI		"lui"
%token LI		"li"
%token LA		"la"
%token SB		"sb"
%token SW		"sw"
%token MOVE		"move"
%token MFHI		"mfhi"
%token MFLO		"mflo"
%token MTHI		"mthi"
%token MTLO		"mtlo"
%token MFC0		"mfc0"
%token MTC0		"mtc0"
%token SYSCALL		"syscall"
%token NOP		"nop"


%start program
%%
//
program
:
| program DIR_TEXT instructions
| program DIR_DATA datas


// Data definitions
datas
:
| datas data

data
// Label
:  LABEL_DEF
{ program_builder.define_data_label(*$1); }

// Uninitialized space
| DIR_SPACE INTEGER
{ program_builder.add_space($2); }

// Values
| DIR_BYTE INTEGER
{ program_builder.add_byte($2); }

| DIR_HALF INTEGER
{ program_builder.add_half($2); }

| DIR_WORD INTEGER
{ program_builder.add_word($2); }
| DIR_WORD LABEL
{ program_builder.add_word(new LabelExp(*$2)); }

| DIR_ASCII STRING
{ program_builder.add_ascii($2); }
| DIR_ASCIIZ STRING
{ program_builder.add_asciiz($2); }

// Instruction definitions
instructions
:
| instructions instruction

instruction
// Label
: LABEL_DEF
{ program_builder.define_inst_label(*$1); }

// Opcodes
| ADD REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_add($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| ADD REGISTER COMMA REGISTER
{ program_builder.add_add($2, $2, $4);
  delete $2;
  delete $4;
}
| ADD REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_addi($2, $4, $6);
  delete $2;
  delete $4;
}
| ADD REGISTER COMMA exp
{ program_builder.add_addi($2, $2, $4);
  delete $2;
}
| ADDU REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_addu($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| ADDU REGISTER COMMA REGISTER
{ program_builder.add_addu($2, $2, $4);
  delete $2;
  delete $4;
}
| ADDU REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_addiu($2, $4, $6);
  delete $2;
  delete $4;
}
| ADDU REGISTER COMMA exp
{ program_builder.add_addiu($2, $2, $4);
  delete $2;
}
| ADDI REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_addi($2, $4, $6);
  delete $2;
  delete $4;
}
| ADDI REGISTER COMMA exp
{ program_builder.add_addi($2, $2, $4);
  delete $2;
}
| ADDIU REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_addiu($2, $4, $6);
  delete $2;
  delete $4;
}
| ADDIU REGISTER COMMA exp
{ program_builder.add_addiu($2, $2, $4);
  delete $2;
}
| SUB REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_sub($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| SUB REGISTER COMMA REGISTER
{ program_builder.add_sub($2, $2, $4);
  delete $2;
  delete $4;
}
| SUB REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_addi($2, $4, new OpExp(new IntExp(0), OpExp::sub, $6));
  delete $2;
  delete $4;
}
| SUBU REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_subu($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| SUBU REGISTER COMMA REGISTER
{ program_builder.add_subu($2, $2, $4);
  delete $2;
  delete $4;
}
| SUBU REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_addiu($2, $4, new OpExp(new IntExp(0), OpExp::sub, $6));
  delete $2;
  delete $4;
}
| NEG REGISTER COMMA REGISTER
{ program_builder.add_sub($2, new Register(Register::general, Cpu::zero), $4);
  delete $2;
  delete $4;
}
| NEG REGISTER
{ program_builder.add_sub($2, new Register(Register::general, Cpu::zero), $2);
  delete $2;
}
| NEGU REGISTER COMMA REGISTER
{ program_builder.add_subu($2, new Register(Register::general, Cpu::zero), $4);
  delete $2;
  delete $4;
}
| NEGU REGISTER
{ program_builder.add_subu($2, new Register(Register::general, Cpu::zero), $2);
  delete $2;
}
| ABS REGISTER COMMA REGISTER
{ program_builder.add_abs($2, $4);
  delete $2;
  delete $4;
}
| ABS REGISTER
{ program_builder.add_abs($2, $2);
  delete $2;
}
| MUL REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_mul($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| MUL REGISTER COMMA REGISTER
{ program_builder.add_mul($2, $2, $4);
  delete $2;
  delete $4;
}
| MUL REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_mul($2, $4, $6);
  delete $2;
  delete $4;
}
| DIV REGISTER COMMA REGISTER
{ program_builder.add_div($2, $4);
  delete $2;
  delete $4;
}
| DIV REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_div($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| DIV REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_div($2, $4, $6);
  delete $2;
  delete $4;
}
| DIVU REGISTER COMMA REGISTER
{ program_builder.add_divu($2, $4);
  delete $2;
  delete $4;
}
| DIVU REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_divu($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| DIVU REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_divu($2, $4, $6);
  delete $2;
  delete $4;
}
| REM REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_rem($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| REM REGISTER COMMA REGISTER
{ program_builder.add_rem($2, $2, $4);
  delete $2;
  delete $4;
}
| REMU REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_remu($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| REMU REGISTER COMMA REGISTER
{ program_builder.add_remu($2, $2, $4);
  delete $2;
  delete $4;
}
| SLL REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_sll($2, $4, $6);
  delete $2;
  delete $4;
}
| SLL REGISTER COMMA exp
{ program_builder.add_sll($2, $2, $4);
  delete $2;
}
| SLL REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_sllv($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| SLL REGISTER COMMA REGISTER
{ program_builder.add_sllv($2, $2, $4);
  delete $2;
  delete $4;
}
| SLLV REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_sllv($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| SLLV REGISTER COMMA REGISTER
{ program_builder.add_sllv($2, $2, $4);
  delete $2;
  delete $4;
}
| SRA REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_sra($2, $4, $6);
  delete $2;
  delete $4;
}
| SRA REGISTER COMMA exp
{ program_builder.add_sra($2, $2, $4);
  delete $2;
}
| SRA REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_srav($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| SRA REGISTER COMMA REGISTER
{ program_builder.add_srav($2, $2, $4);
  delete $2;
  delete $4;
}
| SRAV REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_srav($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| SRAV REGISTER COMMA REGISTER
{ program_builder.add_srav($2, $2, $4);
  delete $2;
  delete $4;
}
| SRL REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_srl($2, $4, $6);
  delete $2;
  delete $4;
}
| SRL REGISTER COMMA exp
{ program_builder.add_srl($2, $2, $4);
  delete $2;
}
| SRL REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_srlv($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| SRL REGISTER COMMA REGISTER
{ program_builder.add_srlv($2, $2, $4);
  delete $2;
  delete $4;
}
| SRLV REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_srlv($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| SRLV REGISTER COMMA REGISTER
{ program_builder.add_srlv($2, $2, $4);
  delete $2;
  delete $4;
}
| ROL REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_rol($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| ROL REGISTER COMMA REGISTER
{ program_builder.add_rol($2, $2, $4);
  delete $2;
  delete $4;
}
| ROL REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_rol($2, $4, $6);
  delete $2;
  delete $4;
}
| ROL REGISTER COMMA exp
{ program_builder.add_rol($2, $2, $4);
  delete $2;
}
| ROR REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_ror($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| ROR REGISTER COMMA REGISTER
{ program_builder.add_ror($2, $2, $4);
  delete $2;
  delete $4;
}
| ROR REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_ror($2, $4, $6);
  delete $2;
  delete $4;
}
| ROR REGISTER COMMA exp
{ program_builder.add_ror($2, $2, $4);
  delete $2;
}
| AND REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_and($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| AND REGISTER COMMA REGISTER
{ program_builder.add_and($2, $2, $4);
  delete $2;
  delete $4;
}
| AND REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_andi($2, $4, $6);
  delete $2;
  delete $4;
}
| AND REGISTER COMMA exp
{ program_builder.add_andi($2, $2, $4);
  delete $2;
}
| ANDI REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_andi($2, $4, $6);
  delete $2;
  delete $4;
}
| ANDI REGISTER COMMA exp
{ program_builder.add_andi($2, $2, $4);
  delete $2;
}
| OR REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_or($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| OR REGISTER COMMA REGISTER
{ program_builder.add_or($2, $2, $4);
  delete $2;
  delete $4;
}
| OR REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_ori($2, $4, $6);
  delete $2;
  delete $4;
}
| OR REGISTER COMMA exp
{ program_builder.add_ori($2, $2, $4);
  delete $2;
}
| ORI REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_ori($2, $4, $6);
  delete $2;
  delete $4;
}
| ORI REGISTER COMMA exp
{ program_builder.add_ori($2, $2, $4);
  delete $2;
}
| XOR REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_xor($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| XOR REGISTER COMMA REGISTER
{ program_builder.add_xor($2, $2, $4);
  delete $2;
  delete $4;
}
| XOR REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_xori($2, $4, $6);
  delete $2;
  delete $4;
}
| XOR REGISTER COMMA exp
{ program_builder.add_xori($2, $2, $4);
  delete $2;
}
| XORI REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_xori($2, $4, $6);
  delete $2;
  delete $4;
}
| XORI REGISTER COMMA exp
{ program_builder.add_xori($2, $2, $4);
  delete $2;
}
| NOR REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_nor($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| NOR REGISTER COMMA REGISTER
{ program_builder.add_nor($2, $2, $4);
  delete $2;
  delete $4;
}
| NOR REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_nor($2, $4, $6);
  delete $2;
  delete $4;
}
| NOR REGISTER COMMA exp
{ program_builder.add_nor($2, $2, $4);
  delete $2;
}
| NOT REGISTER COMMA REGISTER
{ program_builder.add_nor($2, $4, new Register(Register::general, Cpu::zero));
  delete $2;
  delete $4;
}
| NOT REGISTER
{ program_builder.add_nor($2, $2, new Register(Register::general, Cpu::zero));
  delete $2;
}
| SEQ REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_seq($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| SEQ REGISTER COMMA REGISTER
{ program_builder.add_seq($2, $2, $4);
  delete $2;
  delete $4;
}
| SEQ REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_seq($2, $4, $6);
  delete $2;
  delete $4;
}
| SEQ REGISTER COMMA exp
{ program_builder.add_seq($2, $2, $4);
  delete $2;
}
| SNE REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_sne($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| SNE REGISTER COMMA REGISTER
{ program_builder.add_sne($2, $2, $4);
  delete $2;
  delete $4;
}
| SNE REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_sne($2, $4, $6);
  delete $2;
  delete $4;
}
| SNE REGISTER COMMA exp
{ program_builder.add_sne($2, $2, $4);
  delete $2;
}
| SGE REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_sge($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| SGE REGISTER COMMA REGISTER
{ program_builder.add_sge($2, $2, $4);
  delete $2;
  delete $4;
}
| SGE REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_sge($2, $4, $6);
  delete $2;
  delete $4;
}
| SGE REGISTER COMMA exp
{ program_builder.add_sge($2, $2, $4);
  delete $2;
}
| SGEU REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_sgeu($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| SGEU REGISTER COMMA REGISTER
{ program_builder.add_sgeu($2, $2, $4);
  delete $2;
  delete $4;
}
| SGEU REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_sgeu($2, $4, $6);
  delete $2;
  delete $4;
}
| SGEU REGISTER COMMA exp
{ program_builder.add_sgeu($2, $2, $4);
  delete $2;
}
| SGT REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_slt($2, $6, $4);
  delete $2;
  delete $6;
  delete $4;
}
| SGT REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_sgt($2, $4, $6);
  delete $2;
  delete $4;
}
| SGT REGISTER COMMA exp
{ program_builder.add_sgt($2, $2, $4);
  delete $2;
}
| SGTU REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_sltu($2, $6, $4);
  delete $2;
  delete $6;
  delete $4;
}
| SGTU REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_sgtu($2, $4, $6);
  delete $2;
  delete $4;
}
| SGTU REGISTER COMMA exp
{ program_builder.add_sgtu($2, $2, $4);
  delete $2;
}
| SLE REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_sle($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| SLE REGISTER COMMA REGISTER
{ program_builder.add_sle($2, $2, $4);
  delete $2;
  delete $4;
}
| SLE REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_sle($2, $4, $6);
  delete $2;
  delete $4;
}
| SLE REGISTER COMMA exp
{ program_builder.add_sle($2, $2, $4);
  delete $2;
}
| SLEU REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_sleu($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| SLEU REGISTER COMMA REGISTER
{ program_builder.add_sleu($2, $2, $4);
  delete $2;
  delete $4;
}
| SLEU REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_sleu($2, $4, $6);
  delete $2;
  delete $4;
}
| SLEU REGISTER COMMA exp
{ program_builder.add_sleu($2, $2, $4);
  delete $2;
}
| SLT REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_slt($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| SLT REGISTER COMMA REGISTER
{ program_builder.add_slt($2, $2, $4);
  delete $2;
  delete $4;
}
| SLT REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_slti($2, $4, $6);
  delete $2;
  delete $4;
}
| SLT REGISTER COMMA exp
{ program_builder.add_slti($2, $2, $4);
  delete $2;
}
| SLTU REGISTER COMMA REGISTER COMMA REGISTER
{ program_builder.add_sltu($2, $4, $6);
  delete $2;
  delete $4;
  delete $6;
}
| SLTU REGISTER COMMA REGISTER
{ program_builder.add_sltu($2, $2, $4);
  delete $2;
  delete $4;
}
| SLTU REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_sltiu($2, $4, $6);
  delete $2;
  delete $4;
}
| SLTU REGISTER COMMA exp
{ program_builder.add_sltiu($2, $2, $4);
  delete $2;
}
| SLTI REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_slti($2, $4, $6);
  delete $2;
  delete $4;
}
| SLTI REGISTER COMMA exp
{ program_builder.add_slti($2, $2, $4);
  delete $2;
}
| SLTIU REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_sltiu($2, $4, $6);
  delete $2;
  delete $4;
}
| SLTIU REGISTER COMMA exp
{ program_builder.add_sltiu($2, $2, $4);
  delete $2;
}
| BEQ REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_beq($2, $4, $6);
  delete $2;
  delete $4;
}
| BEQ REGISTER COMMA exp COMMA exp
{ program_builder.add_beq($2, $4, $6);
  delete $2;
}
| BEQZ REGISTER COMMA exp
{ program_builder.add_beq($2, new Register(Register::general, Cpu::zero), $4);
  delete $2;
}
| BNE REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_bne($2, $4, $6);
  delete $2;
  delete $4;
}
| BNE REGISTER COMMA exp COMMA exp
{ program_builder.add_bne($2, $4, $6);
  delete $2;
}
| BNEZ REGISTER COMMA exp
{ program_builder.add_bne($2, new Register(Register::general, Cpu::zero), $4);
  delete $2;
}
| BGE REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_bge($2, $4, $6);
  delete $2;
  delete $4;
}
| BGE REGISTER COMMA exp COMMA exp
{ program_builder.add_bge($2, $4, $6);
  delete $2;
}
| BGEU REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_bgeu($2, $4, $6);
  delete $2;
  delete $4;
}
| BGEU REGISTER COMMA exp COMMA exp
{ program_builder.add_bgeu($2, $4, $6);
  delete $2;
}
| BGEZ REGISTER COMMA exp
{ program_builder.add_bgez($2, $4);
  delete $2;
}
| BGEZAL REGISTER COMMA exp
{ program_builder.add_bgezal($2, $4);
  delete $2;
}
| BGT REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_bgt($2, $4, $6);
  delete $2;
  delete $4;
}
| BGT REGISTER COMMA exp COMMA exp
{ program_builder.add_bgt($2, $4, $6);
  delete $2;
}
| BGTU REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_bgtu($2, $4, $6);
  delete $2;
  delete $4;
}
| BGTU REGISTER COMMA exp COMMA exp
{ program_builder.add_bgtu($2, $4, $6);
  delete $2;
}
| BGTZ REGISTER COMMA exp
{ program_builder.add_bgtz($2, $4);
  delete $2;
}
| BLE REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_ble($2, $4, $6);
  delete $2;
  delete $4;
}
| BLE REGISTER COMMA exp COMMA exp
{ program_builder.add_ble($2, $4, $6);
  delete $2;
}
| BLEU REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_bleu($2, $4, $6);
  delete $2;
  delete $4;
}
| BLEU REGISTER COMMA exp COMMA exp
{ program_builder.add_bleu($2, $4, $6);
  delete $2;
}
| BLEZ REGISTER COMMA exp
{ program_builder.add_blez($2, $4);
  delete $2;
}
| BLT REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_blt($2, $4, $6);
  delete $2;
  delete $4;
}
| BLT REGISTER COMMA exp COMMA exp
{ program_builder.add_blt($2, $4, $6);
  delete $2;
}
| BLTU REGISTER COMMA REGISTER COMMA exp
{ program_builder.add_bltu($2, $4, $6);
  delete $2;
  delete $4;
}
| BLTU REGISTER COMMA exp COMMA exp
{ program_builder.add_bltu($2, $4, $6);
  delete $2;
}
| BLTZ REGISTER COMMA exp
{ program_builder.add_bltz($2, $4);
  delete $2;
}
| BLTZAL REGISTER COMMA exp
{ program_builder.add_bltzal($2, $4);
  delete $2;
}
| J exp
{ program_builder.add_j($2);
}
| JAL exp
{ program_builder.add_jal($2);
}
| JR REGISTER
{ program_builder.add_jr($2);
  delete $2;
}
| JALR REGISTER
{ program_builder.add_jalr($2);
  delete $2;
}
| LB REGISTER COMMA exp LPAREN REGISTER RPAREN
{ program_builder.add_lb($2, $4, $6);
  delete $2;
  delete $6;
}
| LB REGISTER COMMA LPAREN REGISTER RPAREN
{ program_builder.add_lb($2, new IntExp(0), $5);
  delete $2;
  delete $5;
}
| LBU REGISTER COMMA exp LPAREN REGISTER RPAREN
{ program_builder.add_lbu($2, $4, $6);
  delete $2;
  delete $6;
}
| LBU REGISTER COMMA LPAREN REGISTER RPAREN
{ program_builder.add_lbu($2, new IntExp(0), $5);
  delete $2;
  delete $5;
}
| LW REGISTER COMMA exp LPAREN REGISTER RPAREN
{ program_builder.add_lw($2, $4, $6);
  delete $2;
  delete $6;
}
| LW REGISTER COMMA LPAREN REGISTER RPAREN
{ program_builder.add_lw($2, new IntExp(0), $5);
  delete $2;
  delete $5;
}
| LUI REGISTER COMMA exp
{ program_builder.add_lui($2, $4);
  delete $2;
}
| LI REGISTER COMMA exp
{ program_builder.add_ori($2, new Register(Register::general, Cpu::zero), $4);
  delete $2;
}
| LA REGISTER COMMA exp LPAREN REGISTER RPAREN
{ program_builder.add_la($2, $4, $6);
  delete $2;
  delete $6;
}
| LA REGISTER COMMA LPAREN REGISTER RPAREN
{ program_builder.add_la($2, new IntExp(0), $5);
  delete $2;
  delete $5;
}
| LA REGISTER COMMA exp
{ program_builder.add_la($2, $4);
  delete $2;
}
| SB REGISTER COMMA exp LPAREN REGISTER RPAREN
{ program_builder.add_sb($2, $4, $6);
  delete $2;
  delete $6;
}
| SB REGISTER COMMA LPAREN REGISTER RPAREN
{ program_builder.add_sb($2, new IntExp(0), $5);
  delete $2;
  delete $5;
}
| SW REGISTER COMMA exp LPAREN REGISTER RPAREN
{ program_builder.add_sw($2, $4, $6);
  delete $2;
  delete $6;
}
| SW REGISTER COMMA LPAREN REGISTER RPAREN
{ program_builder.add_sw($2, new IntExp(0), $5);
  delete $2;
  delete $5;
}
| MOVE REGISTER COMMA REGISTER
{ program_builder.add_addu($2, $4, new Register(Register::general, Cpu::zero));
  delete $2;
  delete $4;
}
| MFHI REGISTER
{ program_builder.add_mfhi($2);
  delete $2;
}
| MFLO REGISTER
{ program_builder.add_mflo($2);
  delete $2;
}
| MTHI REGISTER
{ program_builder.add_mthi($2);
  delete $2;
}
| MTLO REGISTER
{ program_builder.add_mtlo($2);
  delete $2;
}
| MFC0 REGISTER COMMA REGISTER
{ program_builder.add_mfc0($2, $4);
  delete $2;
  delete $4;
}
| MTC0 REGISTER COMMA REGISTER
{ program_builder.add_mtc0($2, $4);
  delete $2;
  delete $4;
}
| SYSCALL
{ program_builder.add_syscall();
}
| NOP
{ program_builder.add_sll(new Register(Register::general, Cpu::zero), new Register(Register::general, Cpu::zero), new IntExp(0));
}

exp:
  exp EXP_ADD  exp { $$ = new OpExp($1, OpExp::add, $3); }
| exp EXP_SUB  exp { $$ = new OpExp($1, OpExp::sub, $3); }
| exp EXP_MUL  exp { $$ = new OpExp($1, OpExp::mul, $3); }
| exp EXP_DIV  exp { $$ = new OpExp($1, OpExp::div, $3); }
| EXP_SUB exp %prec EXP_UMINUS
        { $$ = new OpExp(new IntExp(0), OpExp::sub, $2); }
| LPAREN exp RPAREN { $$ = $2; }
| INTEGER { $$ = new IntExp($1); }
| LABEL { $$ = new LabelExp(*$1); }

%%
void
yy::parser::error(const location &l, const std::string &msg)
{
  std::cerr << l << ": " << msg << std::endl;
  exit_set (exit_parse);
}

